local occ = LibStub("AceAddon-3.0"):GetAddon("oCC")
local _, c = UnitClass("player")
local L, path = occ.L, {"notify", "special"}

if c == "PRIEST" then
	local ev = occ:NewModule("ev", "AceEvent-3.0")
	local name, _, t, st = GetSpellInfo(81661)	--Evangelism
	local tmrShow
	ev.path = path
	ev.defaults = {enable = true}
	ev.options = {
		name = name,
		type = "group",
		args = {enable = {name = ENABLE, type = "toggle"}},
	}
	ev.handler = {
		enable = function(v)
			if v then ev:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			else ev:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			end
		end
	}

	local function OnShow()
		local s, d = GetSpellCooldown(87151)	--Archangel
		if d < 2 then
			occ:ShowShine(t, 20, 5, st)
			tmrShow = nil
		else
			d = s + 30 - GetTime()
			if d < 9 then
				occ:CancelTimer(tmrShow)
				tmrShow = occ:ScheduleTimer(OnShow, d)
			end
		end
	end

	function ev:COMBAT_LOG_EVENT_UNFILTERED(_, _, eventType,
		_, _, _, _, dstGUID, _, _, _, spellName, _, _, c)
		if dstGUID == UnitGUID("player") and spellName == name then
			if (eventType == "SPELL_AURA_APPLIED_DOSE" and c == 5 or
				eventType == "SPELL_AURA_REFRESH") then
				st = GetTime()
				if tmrShow then occ:CancelTimer(tmrShow)
				else occ:ShowShine(t, -1)
				end
				tmrShow = occ:ScheduleTimer(OnShow, 10)
			elseif eventType == "SPELL_AURA_REMOVED" then
				if tmrShow then
					occ:CancelTimer(tmrShow)
					tmrShow = nil
				end
				occ:ShowShine(t, -1)
			end
		end
	end
elseif c == "ROGUE" then
	local dp = occ:NewModule("dp", "AceEvent-3.0")
	local name = GetSpellInfo(2818)
	dp.path = path
	dp.defaults = {enable = true}
	dp.options = {
		name = name,
		type = "group",
		args = {enable = {name = ENABLE, type = "toggle"}},
	}
	dp.handler = {
		enable = function(v)
			if v then dp:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			else dp:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			end
		end
	}
	function dp:COMBAT_LOG_EVENT_UNFILTERED()
		if (arg2 == "SPELL_AURA_APPLIED_DOSE" or arg2 == "SPELL_AURA_REFRESH") and
			arg6 == UnitGUID("target") and arg10:find(name) then
			--{	2818, 2819, 11353, 11354, 25349, 26968, 27187, 57969, 57970}
			for j = 1, 40 do
				local c, d, m, s, t, _
				s, _, t, c, _, d, _, m = UnitDebuff("target", j, "PLAYER")
				if m and c == 5 then
					occ:ShowShine(t, d, 5) break
				elseif not s then break
				end
			end
		end
	end
elseif c == "WARLOCK" then
	local ss, tmrSS = occ:NewModule("ss")
	local name = GetItemInfo(5232) or "Soul Stone"
	if GetLocale() == "zhCN" then
		L["solo"] = "单人"
		L["party"] = "小队"
		L["raid"] = "团队"
		L["Ignore other soul stone"] = "忽略其他人的灵魂石"
		L["Minimal"] = "最小值"
		L["Instance only"] = "仅在副本中有效"
	elseif GetLocale() == "zhTW" then
		L["solo"] = "單人"
		L["party"] = "小隊"
		L["raid"] = "團隊"
		L["Ignore other soul stone"] = "忽略其他人的靈魂石"
		L["Minimal"] = "最小值"
		L["Instance only"] = "僅在副本中有效"
 	end
	ss.path = path
	ss.defaults = {enable = true, ignore = true, instance = true, notify = "party"}
	local function OnSSTimer()
		local b, _, t = GetSpellInfo(20707)
		if GetItemCooldown(5232) == 0 and
			(not ss.profile.instance or IsInInstance()) then
			local n, c
			if ss.profile.notify == "solo" and not UnitBuff("player", b) then
				occ:ShowShine(t)
			elseif ss.profile.notify == "party" and UnitInParty("player") then
				for i = 1, GetNumPartyMembers() do
					n, _, _, _, _, _, _, c = UnitBuff("party"..i, b)
					if n and (not ss.profile.ignore or c ~= "player") then return end
					occ:ShowShine(t)
				end
			elseif ss.profile.notify ~= "solo" and UnitInRaid("player") then
				for i = 1, GetNumRaidMembers() do
					n, _, _, _, _, _, _, c = UnitBuff("raid"..i, b)
					if n and (not ss.profile.ignore or c ~= "player") then return end
					occ:ShowShine(t)
				end
			end
		end
	end
	ss.options = {
		name = name,
		type = "group",
		args = {
			enable = {name = ENABLE, type = "toggle", order = 10},
			ignore = {name = L["Ignore other soul stone"], type = "toggle", order = 20},
			instance = {name = L["Instance only"], type = "toggle", order = 30},
			notify = {
				name = L["Notify"],
				type = "select",
				values = {solo = L["solo"], party = L["party"], raid = L["raid"]},
			},
		}
	}
	ss.handler = {
		enable = function(v)
			if v then tmrSS = occ:ScheduleRepeatingTimer(OnSSTimer, 3)
			else occ:CancelTimer(tmrSS)
			end
		end,
	}
elseif c == "SHAMAN" then
	local mw = occ:NewModule("mw", "AceEvent-3.0")
	local name, _, t = GetSpellInfo(53817)
	mw.path = path
	mw.defaults = {enable = true}
	mw.options = {
		name = name,
		type = "group",
		args = {enable = {name = ENABLE, type = "toggle"}},
	}
	mw.handler = {
		enable = function(v)
			if v then mw:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			else mw:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			end
		end
	}
	function mw:COMBAT_LOG_EVENT_UNFILTERED(_, _, eventType, _, srcGUID, srcName, _, _,
	dstGUID, dstName, _, _, spellID, spellName, _, auraType, spellCount)
		if eventType == "SPELL_CAST_START" and srcGUID == UnitGUID("player") and spellID == 73920 then
			SendChatMessage("倾盆大奶 从天而降", "yell")
		end
		if spellName == name and dstGUID == UnitGUID("player") then
			if (eventType == "SPELL_AURA_APPLIED_DOSE" or eventType == "SPELL_AURA_REFRESH") and
				spellCount == 5 then
				local d
				_, _, _, _, _, d = UnitBuff("player", name)
				occ:ShowShine(t, d, 5)
			elseif eventType == "SPELL_AURA_REMOVED" then
				occ:ShowShine(t, -1)
			end
		end
	end
end
