-- oCC r29 - oblind
-- r29 - 2011-12-15
-- r1 - 2008-11-21

local floor = floor
local pairs = pairs
local tinsert = tinsert
local GetTime = GetTime
local UnitGUID = UnitGUID
local CreateFrame = CreateFrame
local UnitBuff = UnitBuff
local UnitDebuff = UnitDebuff
local GetInventoryItemCooldown = GetInventoryItemCooldown

local AppName, version, NewVersion = "oCC", 29
local TSCD = {	--Trade skill cooldown
	[2259] = {	--炼金术
		[66658] = {
			66658, 66659, 66660, 66662, 66663, 66664,
			53771, 53773, 53774, 53775, 53776, 53777,
			53779, 53780, 53781, 53782, 53783, 53784,
			28566, 28567, 28568, 28569, 28580, 28581,
			28582, 28583, 28584, 28585,
		},
		[60893] = {60893},	--诺森德炼金研究
	},
	[25229] = {	--珠宝加工
		[73478] = {73478},
	},
	[3908] = {	--裁缝
		[75141] = {75141},
		[75142] = {75142},
		[75144] = {75144},
		[75145] = {75145},
		[75146] = {75146},
	},
	[45357] = {[61177] = {61177}, [61288] = {61288}},	--铭文
}
local RaidBuff = {}
local acts, cds, buffs, debuffs, selfbuffs, selfbuffs0, buffs0, debuffs0 = {}, {}, {}, {}, {}
local btns, anchor, ancTSCD = {}
local occ = LibStub("AceAddon-3.0"):NewAddon(AppName, "AceEvent-3.0", "AceTimer-3.0", "LibConfig-1.0")
local reg = LibStub("AceConfigRegistry-3.0")
local modules = {}
local profile, notify, tscd, args, handler
local defaults = {profile = {
	timer = {
		actionBar = {show = true, scale = 1},
		unitFrame = {show = true, scale = 1}
	},
	notify = {enable = true, x = 0, y = -150, p = "CENTER", lock = false,
		scale = 1, alpha = 0.8, fade = "fadeout", buffs = {}, debuffs = {}, special = {},
		selfbuffs = {}
	},
	tscd = {enable = true, lock = false, p = "BOTTOM", x = 0, y = 150, cds = {}}
}}
local sEffects = {}
local sBuffs, sDebuffs, sSelfBuffs, sSpecials = {}, {}, {}, {}
local L, class = setmetatable({}, {__index = function(self, i) return i end})
if GetLocale() == "zhCN" then
	L["Notify"] = "通知"
	L["Config"] = "配置"
	L["Lock"] = "锁定"
	L["Scale"] = "缩放"
	L["Alpha"] = "透明度"
	L["Fade style"] = "消失方式"
	L["Fadeout"] = "渐隐"
	L["Pump"] = "心跳"
	L["Timer"] = "计时"
	L["Show"] = "显示"
	L["Unit frame"] = "单位框体"
	L["Action bar"] = "动作条"
	L["Buff"] = "增益"
	L["Debuff"] = "减益"
	L["Self buff"] = "自身增益"
	L["Special"] = "特效"
	L["Trade skill cooldown"] = "商业技能冷却"
	L["Cooldown"] = "冷却"
	L["Delete"] = "删除"
	L["Report"] = "报告"
	L["%s's %s cooldown will be over at %s, remaining: %s"] = "%s 的 %s 冷却将于 %s 结束, 剩余: %s"
	L["%s's %s cooldown is over for %s\n"] = "%s 的 %s 冷却结束 %s\n"
	L[" day"] = " 天"
	L[" hour"] = " 小时"
	L[" minut"] = " 分钟"
	L[" second"] = " 秒"
	L["Mouse wheel for resize"] = "鼠标滚轮改变大小"
	L["Reset oCC position"] = "重设oCC位置"
	L["New version found"] = "发现新版本"
	L["Current version"] = "当前版本"
elseif GetLocale() == "zhTW" then
	L["Notify"] = "通知"
	L["Config"] = "配置"
	L["Lock"] = "鎖定"
	L["Scale"] = "縮放"
	L["Alpha"] = "透明度"
	L["Fade style"] = "消失方式"
	L["Fadeout"] = "漸隱"
	L["Pump"] = "心跳"
	L["Timer"] = "計時"
	L["Show"] = "顯示"
	L["Unit frame"] = "單位框體"
	L["Action bar"] = "動作條"
	L["Buff"] = "增益"
	L["Debuff"] = "減益"
	L["Self buff"] = "自身增益"
	L["Special"] = "特效"
	L["Trade skill cooldown"] = "商業技能冷卻"
	L["Cooldown"] = "冷卻"
	L["Delete"] = "刪除"
	L["Report"] = "報告"
	L["%s's %s cooldown will be over at %s, remaining: %s"] = "%s 的 %s 冷卻將於 %s 結束, 剩餘: %s"
	L["%s's %s cooldown is over for %s\n"] = "%s 的 %s 冷卻結束 %s\n"
	L[" day"] = " 天"
	L[" hour"] = " 小時"
	L[" minut"] = " 分鐘"
	L[" second"] = " 秒"
	L["Mouse wheel for resize"] = "滑鼠滾輪改變大小"
	L["Reset oCC position"] = "重設oCC位置"
	L["New version found"] = "發現新版本"
	L["Current version"] = "當前版本"
end
occ.L = L

local specials = {
	1022,	--Hand of Protection 保护之手
	10060,	--Power Infusion 能量灌注
	33206,	--Pain Suppression 痛苦压制
}
local ClassBuffs = {
	DEATHKNIGHT = {
		50421,	--Scent of Blood 血之气息
		53386,	--Cinderglacier 灰烬冰川
	},
	DRUID = {
		16870,	--Clearcasting 清晰预兆
		48517,	--Eclipse 月蚀
		48518,	--Eclipse 月蚀
		16886,	--Nature's Grace 自然之赐
		93400,	--Shooting Stars 坠星
	},
	HUNTER = {
		35098,	--Rapid Killing 疾速杀戮
		53220,	--Improved Steady Shot 强化稳固射击
		56453,	--Lock and Load 荷枪实弹
		53257,	--Cobra Strikes 眼镜蛇打击
	},
	MAGE = {
		12536,	--Clearcasting 奥术专注
		48108,	--Hot Streak 法术连击
		54741,	--Firestarter 一触即发
		57761,	--Fireball! 火球！
		44544,	--Fingers of Frost 寒冰指
	},
	PALADIN = {
		59578,	--The Art of War 战争艺术
		53672,	--Infusion of Light 圣光灌注
		53655,	--Judgements of the Pure 纯洁审判
	},
	PRIEST = {
		88688,	--Surge of Light 圣光涌动
		45241, --Focused Will 专注意志
	},
	ROGUE = {
		45182,	--Cheat Death 假死
	},
	SHAMAN = {
		16246,	--Clearcasting 节能施法
		29178,	--Elemental Devastation 元素浩劫
	},
	WARLOCK = {
		6229,	--Shadow Ward 暗影防护结界
		17941,	--Shadow Trance	暗影冥思
		34936,	--Backlash 反冲
		47283,	--Empowered Imp 小鬼增效
		47383,	--Molten Core 熔火之心
		63165,	--Decimation 灭杀
		64368,	--Eradication 根除
		54274,	--Backdraft 爆燃
		54371,	--Nether Protection-Fire 虚空防护
		18118,	--Aftermath 清算
		85383,	--Improved Soul Fire 强化灵魂之火
	},
	WARRIOR = {
		46916,	--Bloodsurge - Bloodsurge 血脉贲张 - 血涌
		50227,	--Sword and Board 剑盾猛击
		52437,	--Sudden Death 猝死
		60503,	--Taste for Blood 血之气息
	},
}
local ClassDebuffs = {
	ROGUE = {
		51693,	--Waylay 打劫
	},
	WARLOCK = {
		18118,	--Aftermath 清算
	},
}
local BuffStack, BuffStack0 = {}, {
	{
		57330,	--Horn of Winter 寒冬号角
		8076,		--Strength of Earth 大地之力
		93435,	--勇气咆哮 Roar of Courage
	},
	{
		1126,	--Mark of the Wild 野性印记
		20217,	--Blessing of Kings 王者祝福
	},
	{
		24932,	--Leader of the Pack 兽群领袖
		29801,	--Rampage 暴怒
		24604,	--Furious Howl 狂怒之嚎
		90309,	--Terrifying Roar 惊人咆哮
	},
	{
		19506,	--Trueshot Aura 强击光环
		30802,	--Unleashed Rage 怒火释放
		55972,	--Abominable Might 憎恶之力
	},
	{
		7302,	--Frost Armor 霜甲术
		6117,	--Mage Armor 法师护甲
		30482,	--Molten Armor 熔岩护甲
	},
	{
		79058,	--Arcane Brilliance 奥术智慧
		61316,	--达拉然光辉
	},
	{
		588,		--心灵之火
		73413,	--心灵意志
	},
	{
		6673,		--Battle Shout 战斗怒吼
		19740,	--Blessing of Might 力量祝福
	},
	{
		5677,		--法力之泉
		19740,	--Blessing of Might 力量祝福
	},
	{
		20154,	--Seal of Righteousness 正义圣印
		20164,	--Seal of Justice 公正圣印
		20165,	--Seal of Light 洞察圣印
	},
	{
		21562,	--Prayer of Fortitude 真言术：韧
		46302,	--K'iru's Song of Victory 基鲁的胜利之歌
		69377,	--Fortitude 坚韧
		90364,	--Qiraji Fortitude 其拉虫群坚韧
		6307,	--Blood Pact 血之契印
		469,	--Commanding Shout 命令怒吼
	},
	{
		324,	--Lightning Shield 闪电之盾
		52127,	--Water Shield 水之护盾
		974,	--Earth Shield 大地之盾
	},
	{
		687,	--Demon Armor 魔甲术
		28176,	--Fel Armor 邪甲术
	},
}
local ClassSelfBuffs = {
	DEATHKNIGHT = {	--Horn of Winter 寒冬号角
		57330,
		enable = {
			[57330] = function()
				return UnitAffectingCombat("player")
			end,
		},
	},
	DRUID = {
		1126,	--Mark of the Wild 野性印记
	},
	HUNTER = {
		19506,	--Trueshot Aura 强击光环
		enable = {
			[19506] = function()
				local r, _
				_, _, _, _, r = GetTalentInfo(2, 11)
				return r > 0
			end,
		},
	},
	MAGE = {
		7302,	--Frost Armor, Mage Armor, Molten Armor 霜甲术, 法师护甲, 火甲术
		79058,	--Arcane Intellect 奥术智慧
	},
	PALADIN = {
		19740,	--Blessing of Might 力量祝福
		20217,	--Blessing of Kings 王者祝福
		20154,	--Seal of Righteousness 正义圣印
		unique = {
			[19740] = {20217},
			[20217] = {19740},
		}
	},
	PRIEST = {
		21562,	--Power Word: Fortitude 真言术：韧
		588,	--Inner Fire 心灵之火
	},
	ROGUE = {},
	SHAMAN = {324},	--Lightning Shield 闪电之盾
	WARLOCK = {
		687,		--Demon Skin 恶魔皮肤
		6307,		--Blood Pact 血之契印
		19028,	--Soul Link 灵魂链接
		enable = {
			[6307] = function()
				return UnitCreatureFamily("pet") == "小鬼"
			end,
			[19028] = function()
				return UnitExists("pet")
			end,
		},
	},
	WARRIOR = {
		469,	--Commanding Shout 命令怒吼
		6673,	--Battle Shout 战斗怒吼
		enable = {
			[469] = function()
				return UnitAffectingCombat("player")
			end,
		},
		unique = {
			[469] = {6673},
			[6673] = {469},
		}
	},
}
profile = defaults.profile
notify, tscd = profile.notify, profile.tscd
do
	local _, c = UnitClass("player")
	buffs0 = ClassBuffs[c]
	debuffs0 = ClassDebuffs[c] or {}
	selfbuffs0 = ClassSelfBuffs[c]
end
for _, v in ipairs(buffs0) do
	sBuffs[v] = GetSpellInfo(v)
	notify.buffs[v] = true
end
if buffs0.disable then
	for _, v in ipairs(buffs0.disable) do
		notify.buffs[v] = false
	end
end
for _, v in ipairs(debuffs0) do
	sDebuffs[v] = GetSpellInfo(v)
	notify.debuffs[v] = true
end
if debuffs0.disable then
	for _, v in ipairs(debuffs0.disable) do
		notify.debuffs[v] = false
	end
end
for _, v in ipairs(BuffStack0) do
	for _, b in ipairs(v) do
		BuffStack[b] = v
	end
end
for _, v in ipairs(selfbuffs0) do
	sSelfBuffs[v] = GetSpellInfo(v)
	notify.selfbuffs[v] = true
end
for i, v in pairs(specials) do

end

local function OnUpdateShine(self)
	local t, dt = GetTime()
	dt = self.et - t + 1
	if dt >= 0 then
		if notify.fade == "pump" then
			self:SetScale((0.5 + 1.5 * dt) * notify.scale)
		end
		self:SetAlpha(dt * notify.alpha)
	else
		self:Hide()
		btns[self.icon:GetTexture()] = nil
		self:SetScript("OnUpdate", nil)
		if self.tmr then occ:CancelTimer(self.tmr) self.tmr = nil end
		for i = 1, #btns - 1 do
			if btns[i].et - t < 1 then
				for j = i + 1, #btns do
					if btns[j].et - t > 1 then
						btns[i], btns[j] = btns[j], btns[i]
						i, j = btns[i], btns[j]
						i.p, j.p = j.p, i.p
						i:SetPoint("CENTER", i.p, "CENTER", 0, 0)
						j:SetPoint("CENTER", j.p, "CENTER", 0, 0)
						i:SetParent(i.p) j:SetParent(j.p)
						break
					end
				end
			end
		end
	end
end

local function OnUpdateCooldown(self)
	local t0 = GetTime()
	if t0 - self.t0 >= 0.1 then
		local l, t, w, s = self.s + self.d - t0, self.t
		if l >= 86400 then
			s = (floor(l / 86400) + 1).."d"
		elseif l >= 3600 then
			s = (floor(l / 3600) + 1).."h"
		elseif l >= 60 then
			s = (floor(l / 60) + 1).."m"
		elseif l >= 0 then
			s = floor(l + 1)
		else
			if l > -0.5 and self.i then
				occ:ShowShine(self.i)
			end
			self:Hide() return
		end
		if l > 540 and l < 3600 or l > 32400 and l < 86400 then w = 18
		elseif l > 9 then w = 22
		else w = 27
		end
		if s ~= t:GetText() then t:SetText(s) end
		local p = self:GetParent():GetParent()
		if p.unit and UnitExists(p.unit) then
			w = w * profile.timer.unitFrame.scale
		else w = w * profile.timer.actionBar.scale
		end
		w = floor(w * self:GetWidth() / 36 + 0.5)
		if w == 0 then return end
		local f, s = t:GetFont()
		if w ~= floor(s + 0.5) then t:SetFont(f, w, "OUTLINE") end
		local r0, g0, r, g, b = t:GetTextColor()
		if l <= 5 then
			if l - floor(l) > 0.5 then r, g = 1, 1
			else r, g = 1, 0
			end
		else r, g = 0, 1
		end
		if r ~= r0 or g ~= g0 then t:SetTextColor(r, g, 0) end
		self.t0 = t0
	end
end

local function SetTimer(self, start, duration)
	local p, f, t = self:GetParent(), cds[self]
	if p.unit and UnitExists(p.unit) then
		if not profile.timer.unitFrame.show then
			if f then f:Hide() end
			return
		end
	elseif not profile.timer.actionBar.show then
		if f then f:Hide() end
		return
	end
	if duration > 2 then
		if not f then
			local p, h
			f = CreateFrame("Frame", nil, self)
			f:SetAllPoints(self)
			f:SetFrameLevel(self:GetFrameLevel() + 1)
			t = f:CreateFontString(nil, "OVERLAY", "ChatFontNormal")
			if self:GetReverse() then p, h = "BOTTOMRIGHT", "RIGHT"
			else p, h = "TOPLEFT", "LEFT"
			end
			t:SetPoint(p, f, p)
			t:SetJustifyH(h)
			t:SetWidth(self:GetWidth() * 2)
			f.t, cds[self] = t, f
			f:SetScript("OnUpdate", OnUpdateCooldown)
		end
		local a = p.action
		if a then f.i = GetActionTexture(a) end
		f.s, f.d, f.t0 = start, duration, 0
		f:Show() f.t:Show()
	elseif f and f:IsVisible() then
		if duration > 1.5 or f.s + f.d - GetTime() > duration then
			f:Hide() f.s = 0
		end
	end
	if p.action and not acts[self] and not self:GetReverse() then
		acts[self] = 0
	end
end
hooksecurefunc("CooldownFrame_SetTimer", SetTimer)

local tmrICD = {}
local function UpdateItemCooldown()
	local t = GetTime()
	for i = 1, 19 do
		local s, d = GetInventoryItemCooldown("player", i)
		if tmrICD[i] and (d < 10 or tmrICD[i].s ~= s) then
			occ:CancelTimer(tmrICD[i].t) tmrICD[i] = nil
		end
		if d >= 10 and not tmrICD[i] then
			tmrICD[i] = {	s = s, t = occ:ScheduleTimer(
				function(i)
					occ:ShowShine(GetInventoryItemTexture("player", i))
					tmrICD[i] = nil
				end, d - t + s, i)
			}
		end
	end
end

local tmrSelfBuff
local function OnSelfBuffTimer()
	if not HasFullControl() or IsResting() or
		UnitIsDeadOrGhost("player") then return end
	local f, t, _
	for b, x in pairs(selfbuffs) do
		if x then
			if selfbuffs0.enable and selfbuffs0.enable[b] and
				not selfbuffs0.enable[b]() then return end
			n, _, t = GetSpellInfo(b)
			if n then
				f = false
				if type(x) == "table" then
					for _, v in ipairs(x) do
						if UnitBuff("player", v) then
							f = true break
						end
					end
				elseif UnitBuff("player", n) then f = true
				end
				if not f then
					occ:ShowShine(t)
				end
			end
		end
	end
end

local function TimeToStr(t)
	local x, s, p = {86399, 3599, 59, 0}, {" day", " hour", " minut", " second"}
	for i = 1, #x do
		if t > x[i] then p = i break end
	end
	return format("%3.1f", t / (x[p] + 1))..L[s[p]]
end

--local cTSCD, tmrTSCD, TSCDFrame = 1
local cTSCD, tmrTSCD = 1
local function OnTSCDTimer()
	local t, s = time(), ""
	for _, cd in pairs(tscd.cds) do
		local dt = t - cd.et
		if cd.enable and dt > 0 then
			s = s..format(L["%s's %s cooldown is over for %s\n"], cd.p,
				GetSpellLink(cd.id), TimeToStr(dt))
		end
	end
	if s == "" then TSCDFrame:Hide()
	else
		TSCDFrame:Show()
		TSCDFrame.text:SetText(s)
		TSCDFrame.text:SetTextColor(cTSCD, 1 - cTSCD, 0)
		cTSCD = 1 - cTSCD
	end
end

local function GetCooldown(p, spell, cd)
	local l, s = GetSpellLink(spell)
	if cd > 0 then
		return format(L["%s's %s cooldown will be over at %s, remaining: %s"],
			p, l, date("%c", time() + cd), TimeToStr(cd))
	else
		cd = -cd
		return format(L["%s's %s cooldown is over for %s\n"], p, l, TimeToStr(cd))
	end
end

local function PrintCooldown(s)
	RaidNotice_AddMessage(RaidWarningFrame, s, {g = 1})
	print(s)
end

handler = {
	notify = {
		lock = function(v)
			if v then
				anchor:Hide()
				for i = 1, #btns do
					btns[i]:Hide()
				end
			else
				anchor:Show()
				for i = 1, #btns do
					btns[i]:SetScale(1)
					btns[i]:SetAlpha(notify.alpha)
					btns[i].icon:SetTexture("Interface\\Icons\\Ability_Hunter_Readiness")
					btns[i]:Show()
				end
			end
		end,
		scale = function(v)
			anchor:SetScale(notify.scale)
			for i = 1, #btns do
				btns[i].p:SetScale(notify.scale)
			end
			anchor.lblScale:SetText((notify.scale * 100).."%")
		end,
		buffs = function(i, v)
			local n = GetSpellInfo(i)
			buffs[n] = v
		end,
		debuffs = function(i, v)
			local n = GetSpellInfo(i)
			debuffs[n] = v
		end,
		selfbuffs = function(i, v)
			if v then
				if BuffStack[i] then
					selfbuffs[i] = {}
					for _, b in ipairs(BuffStack[i]) do
						b = GetSpellInfo(b)
						tinsert(selfbuffs[i], b)
					end
					if selfbuffs0.unique and selfbuffs0.unique[i] then
						for _, b in pairs(selfbuffs0.unique[i]) do
							b = GetSpellInfo(b)
							tinsert(selfbuffs[i], b)
						end
					end
					return
				end
			end
			selfbuffs[i] = v
		end,
		special = {},
	},
	tscd = {
		enable = function(v)
			if v then
				if next(tscd.cds) then
					tmrTSCD = occ:ScheduleRepeatingTimer(OnTSCDTimer, 1)
					TSCDFrame:Show()
				end
			else
				if tmrTSCD then
					occ:CancelTimer(tmrTSCD)
					tmrTSCD = nil
					TSCDFrame:Hide()
				end
			end
		end,
		lock = function(v)
			if v then ancTSCD:Hide()
			else ancTSCD:Show()
			end
		end,
	},
}

args = {
	desc = {
		name = AppName.." r"..version,
		type = "description",
		order = 10,
	},
	timer = {
		name = L["Timer"],
		type = "group",
		order = 30,
		args = {
			actionBar = {
				name = L["Action bar"],
				type = "group",
				inline = true,
				order = 10,
				args = {
					show = {
						name = L["Show"],
						type = "toggle",
						order = 10,
					},
					scale = {
						name = L["Scale"],
						type = "range",
						min = 0.5,
						max = 1.5,
						step = 0.05,
						isPercent = true,
						order = 20,
					},
				},
			},
			unitFrame = {
				name = L["Unit frame"],
				type = "group",
				inline = true,
				order = 20,
				args = {
					show = {
						name = L["Show"],
						type = "toggle",
						order = 10,
					},
					scale = {
						name = L["Scale"],
						type = "range",
						min = 0.5,
						max = 1.5,
						step = 0.05,
						isPercent = true,
						order = 20,
					},
				},
			},
		},
	},
	notify = {
		name = L["Notify"],
		type = "group",
		order = 40,
		args = {
			enable = {
				name = ENABLE,
				type = "toggle",
				order = 10,
			},
			lock = {
				name = L["Lock"],
				type = "toggle",
				order = 20,
			},
			scale = {
				name = L["Scale"],
				type = "range",
				min = 0.5,
				max = 2,
				step = 0.05,
				isPercent = true,
				order = 30,
			},
			alpha = {
				name = L["Alpha"],
				type = "range",
				max = 1,
				step = 0.05,
				isPercent = true,
				order = 40,
			},
			fade = {
				name = L["Fade style"],
				type = "select",
				values = {
					fadeout = L["Fadeout"],
					pump = L["Pump"],
				},
				order = 50,
			},
			resetpos = {
				name = L["Reset oCC position"],
				type = "execute",
				order = 60,
				func = function()
					anchor:Show()
					anchor:ClearAllPoints()
					anchor:SetPoint("CENTER", UIParent, "CENTER", 0, -150)
					notify.x, notify.y = 0, -150
					notify.p, notify.lock = "CENTER"
				end
			},
			buffs = {
				name = L["Buff"],
				type = "multiselect",
				values = sBuffs,
				order = 70,
			},
			debuffs = {
				name = L["Debuff"],
				type = "multiselect",
				values = sDebuffs,
				order = 80,
			},
			selfbuffs = {
				name = L["Self buff"],
				type = "multiselect",
				values = sSelfBuffs,
				order = 90,
			},
			special = {
				name = L["Special"],
				type = "group",
				inline = true,
				order = 100,
				args = {},
			},
		},
	},
	tscd = {
		name = L["Trade skill cooldown"],
		type = "group",
		order = 50,
		args = {
			enable = {
				name = ENABLE,
				type = "toggle",
				order = 10,
			},
			lock = {
				name = L["Lock"],
				type = "toggle",
				order = 20,
			},
			report = {
				name = L["Report"],
				type = "execute",
				order = 30,
				func = function()
					local t = time()
					for _, cd in pairs(tscd.cds) do
						if cd.et - t > 1 then
							PrintCooldown(GetCooldown(cd.p, cd.id, cd.et - t))
						end
					end
				end,
			},
			resetpos = {
				name = L["Reset oCC position"],
				type = "execute",
				order = 40,
				func = function()
					ancTSCD:ClearAllPoints()
					ancTSCD:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 150)
					ancTSCD:Show()
					tscd.x, tscd.y = 0, 150
					tscd.p, tscd.lock = "BOTTOM"
				end
			},
			cds = {
				name = L["Cooldown"],
				type = "group",
				inline = true,
				order = 50,
				args = {}
			},
		},
	},
	--[[debug = {
		name = L["debug"],
		type = "execute",
		order = 999,
		func = function()
			print("buffs")
			for c, x in pairs(ClassBuffs) do
				for _, id in ipairs(x) do
					local n = GetSpellInfo(id)
					if not n then print(c, id) end
				end
			end
			print("debuffs")
			for c, x in pairs(ClassDebuffs) do
				for _, id in ipairs(x) do
					local n = GetSpellInfo(id)
					if not n then print(c, id) end
				end
			end
			print("trade skill")
			for t, x in pairs(TSCD) do
				local n = GetSpellInfo(t)
				for s, t in pairs(x) do
					for _, id in ipairs(t) do
						local m = GetSpellInfo(id)
						if not m then print(n, s, id) end
					end
				end
			end
			print("self buffs")
			for c, x in pairs(ClassSelfBuffs) do
				for _, id in ipairs(x) do
					local n = GetSpellInfo(id)
					if not n then print(c, id) end
				end
			end
		end,
	},]]
}

local sst = 0
function occ:ShowShine(tx, d, c, t)	--d: -2: 更新, -1: 闪, >= 0: 显示
	if not notify.enable then return end
	local b, e, f = btns[tx], 1
	t = t or GetTime()
	c, d = c or 1, d or 0
	if d == 0 and t - sst < 0.1 then return end
	if not b then
		for i = 1, #btns do
			if btns[i].et + 1 < t then b = btns[i] break end
		end
	end
	if not b then return end
	btns[tx], sst = b, t
	if c > 1 then b.count:Show() b.count:SetText(c)
	else b.count:Hide()
	end
	if b.tmr then b:CancelTimer(b.tmr) b.tmr = nil end
	if d < -1 then return
	elseif d == -1 then d, f = 0, OnUpdateShine
	else
		b.tmr = b:ScheduleTimer(function(b)
			b.tmr = nil
			if not b:GetScript("OnUpdate") then
				occ:ShowShine(b.icon:GetTexture(), -1)
			end
		end, d + 1, b)
	end
	if d < 2 then e = 0 end
	b:SetScript("OnUpdate", f)
	b.et = t + d
	b.icon:SetTexture(tx)
	b:SetAlpha(notify.alpha)
	b:SetScale(1)
	CooldownFrame_SetTimer(b.cd, t, d, e)
	b:Show()
	return b
end

local function OnVersion(sender, addon, v)
	v = tonumber(v:match("%d+"))
	if v > NewVersion then
		print("|cff00ff00oCC "..L["New version found"]..": r"..v)
		print("|cffff0000oCC "..L["Current version"]..": r"..version)
		NewVersion = v
	end
end

local function AddTradeskillCooldown(p, id, k)
	args.tscd.args.cds.args[k] = {
		name = p.." - "..GetSpellLink(id),
		type = "group",
		args = {
			cd = {
				name = function()
					return GetCooldown(p, id, tscd.cds[k].et - time())
				end,
				type = "description",
				order = 10,
			},
			enable = {
				name = ENABLE,
				type = "toggle",
				order = 20,
			},
			delete = {
				name = L["Delete"],
				type = "execute",
				order = 30,
				func = function()
					tscd.cds[k] = nil
					args.tscd.args.cds.args[k] = nil
				end,
			}
		},
	}
end

local PreNewModule = occ.NewModule
function occ:NewModule(...)
	local m = PreNewModule(self, ...)
	tinsert(modules, m)
	return m
end

local function UpdateProfile(m)
	local n, p, path = m:GetName(), profile, m.path or {}
	for i = 1, #path do p = p[path[i]] end
	m.profile = p[n]
end

function occ:OnProfileChanged(event, db, name)
	profile = db.profile
	notify, tscd = profile.notify, profile.tscd
	anchor:ClearAllPoints()
	anchor:SetPoint(notify.p, UIParent, notify.p, notify.x, notify.y)
	local x, y = {0, -72, 72, 0, -72, 72}, {-28, -28, -28, -100, -100, -100}
	for i = 1, 6 do
		btns[i].p:SetPoint("TOP", anchor, "TOP", x[i], y[i])
	end
	ancTSCD:ClearAllPoints()
	ancTSCD:SetPoint(tscd.p, UIParent, tscd.p, tscd.x, tscd.y)
	TSCDFrame:SetPoint("TOP", ancTSCD, "BOTTOM", 0, 0)
	wipe(args.tscd.args.cds.args)
	local t = time()
	for k, cd in pairs(tscd.cds) do
		AddTradeskillCooldown(cd.p, cd.id, k)
		if tscd.enable and cd.enable and cd.et - t > 0 then
			local s = GetCooldown(cd.p, cd.id, cd.et - t)
			self:ScheduleTimer(PrintCooldown, 5, s)
		end
	end
	for _, m in ipairs(modules) do
		m:UpdateProfile()
		if m.OnProfileChanged then m:OnProfileChanged(name) end
	end
end

function occ:VARIABLES_LOADED()
	for _, m in ipairs(modules) do
		local n, o, p, h, path = m:GetName(), args, profile,
			handler, m.path or {}
		for i = 1, #path do
			if not o[path[i]] then o[path[i]] = {args = {}} end
			o, p, h = o[path[i]].args, p[path[i]], h[path[i]]
		end
		o[n], p[n], h[n] = m.options, m.defaults, m.handler
		m.UpdateProfile = UpdateProfile
	end
	self:CreateOptions(AppName, args, handler, "occ", "oCCDB", defaults)
	tmrSelfBuff = self:ScheduleRepeatingTimer(OnSelfBuffTimer, 3)
	for i = 1, 40 do
		local b, d, e, _
		b, _, tx, _, _, d = UnitBuff("player", i)
		if not b then break end
		if d >= 120 then RaidBuff[b] = true end
	end
	UpdateItemCooldown()
	NewVersion = version
	LibStub("LibVersionCheck-1.0"):RegisterVersion(AppName, tostring(version), OnVersion)
end

function occ:COMBAT_LOG_EVENT_UNFILTERED(_, _, eventType, _, srcGUID, srcName, _, _,
	dstGUID, dstName, _, _, spellID, spellName, _, auraType, spellCount)
	if eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH"
		or eventType == "SPELL_AURA_APPLIED_DOSE" or eventType == "SPELL_AURA_REMOVED_DOSE" then
		local c, d, t
		if UnitGUID("player") == dstGUID and auraType == "BUFF" then
			_, _, t, c, _, d = UnitBuff("player", spellName)
			if d and d >= 120 then RaidBuff[spellName] = true end
			if buffs[spellName] then
				if spellCount then d = -2 end
				if t then self:ShowShine(t, d, c)
				end
			end
		elseif UnitGUID("target") == dstGUID and auraType == "DEBUFF" then
			_, _, t, c, _, d = UnitDebuff("target", spellName)
			if debuffs[spellName] then
				if spellCount then d = -2 end
				self:ShowShine(t, d, c)
			end
		end
	elseif eventType == "SPELL_AURA_REMOVED" then
		local t
		if UnitIsUnit(dstName, "player") and auraType == "BUFF" then
			_, _, t = GetSpellInfo(spellID)
			if RaidBuff[spellName] then
				self:ShowShine(t)
				RaidBuff[spellName] = nil
			end
			if buffs[spellName] then
				self:ShowShine(t, -1)
			end
		elseif UnitGUID("target") == dstGUID and auraType == "DEBUFF" then
			_, _, t = GetSpellInfo(spellID)
			if debuffs[spellName] then
				self:ShowShine(t, -1)
			end
		end
		if UnitGUID("player") == srcGUID then
			if auraType == "DEBUFF" then

			else

			end
		end
	elseif eventType == "ENCHANT_REMOVED" and UnitGUID("player") == dstGUID then
		self:ShowShine(GetItemIcon(spellName))
	end
end

local function InTSCD(n)
	for ti, ts in pairs(TSCD) do
		if GetTradeSkillLine() == GetSpellInfo(ti) then
			for tid, ids in pairs(ts) do
				for _, id in ipairs(ids) do
					if GetSpellInfo(id) == n then
						return tid, id
					end
				end
			end
		end
	end
end

function occ:TRADE_SKILL_UPDATE()
	if IsTradeSkillLinked() then return end
	local p = UnitName("player")
	for i = 1, GetNumTradeSkills() do
		local tid, id = InTSCD(GetTradeSkillInfo(i))
		if tid then
			local t, j, k, cd = time(), 1
			repeat
				k, j = tostring(j), j + 1
				cd = tscd.cds[k] or {et = t, enable = true,
					p = p, tid = tid, id = id}
			until cd.p == p and cd.tid == tid
			if cd.p == p and cd.tid == tid then
				tscd.cds[k] = cd
				AddTradeskillCooldown(p, id, k)
				cd = GetTradeSkillCooldown(i)
				if cd and tscd.cds[k].et < t + cd - 1 then
					local s = GetCooldown(p, id, cd)
					PrintCooldown(s)
					tscd.cds[k].et = t + (cd or 0)
				end
				if tscd.enable and not tmrTSCD then
					tmrTSCD = self:ScheduleRepeatingTimer(OnTSCDTimer, 1)
				end
			end
		end
	end
end

function occ:TRADE_SKILL_SHOW()
	self:TRADE_SKILL_UPDATE()
end

function occ:UNIT_INVENTORY_CHANGED()
	if arg1 == "player" then UpdateItemCooldown() end
end

uict = 0
function occ:ACTIONBAR_UPDATE_COOLDOWN()
	local t0 = GetTime()
	for cd, t in pairs(acts) do
		local s, d = GetActionCooldown(cd:GetParent().action)
		if s and d > 2 and t0 - t > 0.1 then
			CooldownFrame_SetTimer(cd, s, d, 1)
			acts[cd] = t0
		end
	end
	if t0 - uict > 0.1 then
		UpdateItemCooldown()
		uict = t0
	end
end

local function OnAnchorMouseDown(self, btn)
	if btn == "LeftButton" then
		self:StartMoving()
		self.moving = true
	end
end

local function OnAnchorMouseUp(self, btn)
	if self.moving then
		self:StopMovingOrSizing()
		self.moving = false
		local p, x, y, _
		if self.OnMoved then
			p, _, _, x, y = self:GetPoint()
			self:OnMoved(p, x, y)
		end
	end
end

local function CreateAnchor(w, h, text)
	local a, t = CreateFrame("Frame", nil, UIParent)
	a:SetWidth(w) a:SetHeight(h)
	a:SetScript("OnMouseDown", OnAnchorMouseDown)
	a:SetScript("OnMouseUp", OnAnchorMouseUp)
	a:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets = {left = 5, right = 5, top = 5, bottom = 5}
	})
	a:SetBackdropBorderColor(1, 1, 1)
	a:SetBackdropColor(0.1, 0.1, 0.1)
	a:SetMovable(true) a:EnableMouse(true)
	t = a:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	t:SetAllPoints(a)
	t:SetText(text)
	a.label = t
	return a
end

do
	local t = CreateAnchor(225, 180, "oCC\n"..L["Mouse wheel for resize"])
	t:EnableMouseWheel(true)
	t:SetFrameLevel(2)
	anchor = t
	t = anchor:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	t:SetPoint("TOP", anchor, "TOP", 0, -15)
	anchor.lblScale = t
	t = CreateFrame("Button", nil, anchor, "OptionsButtonTemplate")
	t:SetText(L["Lock"])
	t:SetWidth(40)
	t:SetHeight(25)
	t:SetPoint("TOPRIGHT", anchor, "TOPRIGHT", -1, -1)
	t:SetScript("OnClick", function()
		notify.lock = true
		handler.notify.lock(true)
		reg:NotifyChange(AppName)
	end)
	anchor.btnLock = t
	occ.anchor = anchor
	for i = 1, 6 do
		local n, p = "oCCButton"..i, CreateFrame("Frame", nil, UIParent)
		p:SetWidth(72) p:SetHeight(72)
		t = CreateFrame("Frame", n, p, "TargetBuffFrameTemplate")
		LibStub("AceTimer-3.0"):Embed(t)
		t:SetPoint("CENTER", p, "CENTER", 0, 0)
		t:SetWidth(72) t:SetHeight(72)
		t:EnableMouse(false)
		t.icon, t.count, t.cd, t.p, t.unit, t.et =
			_G[n.."Icon"], _G[n.."Count"], _G[n.."Cooldown"], p, 0, 0
		--t.icon:SetBlendMode("ADD")
		local f = {t.count:GetFont()}
		f[2] = f[2] * 2
		t.count:SetFont(unpack(f))
		btns[i] = t
	end
	ancTSCD = CreateAnchor(120, 30, L["Trade skill cooldown"])
	t = CreateFrame("Frame", "TSCDFrame", UIParent)
	t:SetSize(500, 100)
	t.text = t:CreateFontString(nil, "ARTWORK", "ChatFontNormal")
	t.text:SetAllPoints(t)
	TSCDFrame = t
end

anchor:SetScript("OnMouseWheel", function(self, v)
	v = v > 0 and 0.05 or -0.05
	notify.scale = notify.scale + v
	if notify.scale > 2 then notify.scale = 2
	elseif notify.scale < 0.5 then notify.scale = 0.5
	end
	handler.notify.scale(notify.scale)
	reg:NotifyChange(AppName)
end)

function anchor:OnMoved(p, x, y)
	notify.p, notify.x, notify.y = p, x, y
end

function TSCDFrame:OnMoved(p, x, y)
	tscd.p, tscd.x, tscd.y = p, x, y
end

occ:RegisterEvent("TRADE_SKILL_SHOW")
occ:RegisterEvent("TRADE_SKILL_UPDATE")

occ:RegisterEvent("VARIABLES_LOADED")
occ:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
occ:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN")
occ:RegisterEvent("UNIT_INVENTORY_CHANGED")

occ.btns = btns
occ.buffs, occ.debuffs, occ.selfbuffs = buffs, debuffs, selfbuffs
oCC = occ
